
SET TALK OFF
CLEAR ALL
PRIVATE ALL LIKE l*

*prompt the user for a directory
lDirectory = GETDIR(CURDIR(), "Select a directory containing tables:")

* make sure they selected one
IF !EMPTY(lDirectory)

*       *read all of the names of tables into an array
        lHits = ADIR(lTables, lDirectory + "*.DBF")

*       *make sure we have found some tables
        IF lHits == 0
                WAIT WINDOW "No tables found in " + lDirectory
        ELSE
                WAIT WINDOW "Processing tables..." NOWAIT
                SELECT 0

*                       *we need some temporary work space
                CREATE CURSOR work (FileName C(8), StrucList M(10))

*               *process each table in the array
                FOR lCount = 1 TO lHits

*                       *get a temporary file name
                        lTempFile = SYS(3) + ".TXT"

*                           *build the full path to the file, then open the table
                        lFileSpec = lDirectory + lTables[lCount, 1]
                        SELECT 0
                        USE (lFileSpec)

*                       *write the structure info out to the temporary file
                        DISPLAY STRUCTURE NOCONSOLE TO FILE (lTempFile)

*                       *add a new record for this table
                        INSERT INTO work (FileName) VALUES (lTables[lCount,1])

*                       *we no longer need the table open
                         USE
                        SELECT work

*                       *load the temporary file into the memo field
                        APPEND MEMO StrucList FROM (lTempFile)

*                       *ensure we clean up the temporary file
                        DELETE FILE (lTempFile)

*                 *any further processing goes here, for instance one might
*                 *want to parse out useful info into separate fields

                ENDFOR
                GO TOP

*               *this is the easiest way to write to a text file
                SET TEXTMERGE ON
                SET TEXTMERGE TO struc.txt NOSHOW
                \Table Structure Listing
                  \-----------------------

*               *for each record, output the structure memo
                SCAN
                        \<<StrucList>>
                ENDSCAN
                SET TEXTMERGE TO
                SET TEXTMERGE OFF
                USE
                WAIT WINDOW ALLTRIM(STR(lHits)) + " tables processed!" NOWAIT
        ENDIF
ENDIF
RETURN










SAVE INDEXES AND FILTERS FOR TABLES IN A DIRECTORY (Eli Linkov)

*INDEXSAV.PRG
*       this program can be used to set up a .DBF in the system directory of
a
*       project which holds the project's table names and the index (and
filter,
*       if any names of each table. The table name is DBINFO.DBF.
*       The structure of the table is
*                       field   dbfname   12 chars
*                       field   infomemo   memo field
*
*                       The memo field will hold the index name, index
expression
*               and filter, if any, as indexname/expression%filter
*                       on one line of the memo per index
*
*       This program should be run to create the dbfinfo table and ass'd
memo
*       once the system is ready for installation.
*       The table/memo should be installed at the user site in the "system"
*   directory, together with an EXE version of the INDEXMAK program.
*       The INDEXMAK.EXE should only be available via the file manager to
*       the system caretaker, and should not have an program manager icon
*        associated with it.
*       To recover indexing on the project tables, INDEXMAK.EXE should be
run
*       if the indexes are suspected of being corrupted.

CLOSE DATABASES

* the next 2 lines should be amended to suit the project path names
datapath =  "C:\sxc\sxcbuild\"          && where the indexed tables are
workpath =  "C:\sxc\sxcmaint\"           && where the system EXE is

IF NOT FILE(workpath + "dbfinfo.dbf")
        SET DEFAULT TO (workpath)

        * create the table to be used by INDEXMAK.PRG
        CREATE TABLE dbfinfo (dbfname C(12), infomemo m)
ENDIF

SET DEFAULT TO &datapath

DIMENSION filelist(1)
=ADIR(filelist,"*.dbf")

CLOSE DATA
SET DEFAULT TO &workpath

SELECT 0
USE dbfinfo EXCLUSIVE
SET SAFETY OFF
ZAP
SET SAFETY ON

APPEND FROM ARRAY filelist
RELEASE filelist
GO TOP
SET DEFAULT TO &datapath
SCAN
        TEXT = ALLTRIM(dbfname)
        IF TEXT = "DBFINFO.DBF"
        ELSE
                REPLACE dbfname WITH LEFT(TEXT,LEN(TEXT) - 4)
                SELECT 0
                USE  (dbfinfo.dbfname) EXCLUSIVE
                DIMENSION taglist(1,3)
                indexstr = ""
                arrct = 1
                DO WHILE NOT EMPTY(TAG(arrct))
                        taglist(arrct,1) = TAG(arrct)           && the tag
name
                        taglist(arrct,2) = SYS(14,arrct)        && the tag
expression
                        taglist(arrct,3) = sys(2021,arrct)      && the tag
filter (if any)
                        arrct = arrct + 1
                        DIMENSION taglist(arrct,3)
                ENDDO
                SELECT dbfinfo
                FOR x = 1 TO arrct - 1
                   indexstr=indexstr+taglist(x,1)+"/"+taglist(x,2);
                   +"%"+taglist(x,3)+CHR(13)
                ENDFOR
                REPLACE infomemo WITH indexstr
        ENDIF
ENDSCAN
SET DEFAULT TO &workpath
CLOSE DATA



*INDEXMAK.PRG
*       This program is used to recover indexes when the project tables are
*       suspected of being corrupted.  It uses the DBFINFO.DBF table
produced
*       by the program INDEXSAV.PRG to recover the index names, expressions
and
*       filters and re-applies this information to the tables.
*
*       This program should be installed at the user site as an EXE file,
only
*       useable via the file manager. It should not have an icon associated
*       with it for use via the program manager.
*
* the table was set up by indexsav.prg in the system directory
* fields - dbfname      C 12
*        - infomemo     M

CLOSE DATABASES

* set this path for data tables & system EXE
datapath =  "C:\sxc\sxcbuild\"
workpath = "c:\sxc\sxcmaint\"

SET DEFAULT TO &workpath
SELECT 0
USE dbfinfo EXCLUSIVE
SET SAFETY OFF
GO TOP
SET DEFAULT TO &datapath
SCAN
        TEXT = ALLTRIM(dbfname)
        IF TEXT = "DBFINFO.DBF"
        ELSE
           SELECT 0
           USE (dbfinfo.dbfname) EXCLUSIVE
           DELETE TAG ALL

           memct = 1
           fred = dbfinfo.infomemo
           IF NOT EMPTY(fred)
               DO WHILE NOT EMPTY(MLINE(dbfinfo.infomemo,memct))
                     fred = ALLTRIM(MLINE(dbfinfo.infomemo,memct))
                     colno1 = AT("/",fred)
                     colno2 = AT("%",fred)
                     tagfield = LEFT(fred,colno1 - 1)
&& tag name
                     tagname = SUBSTR(fred,colno1 + 1,;
                         (colno2 - colno1 - 1)) && tag expression
                     tagfilt = alltrim(RIGHT(fred,LEN(fred) - colno2))
&& tag filter
                     IF tagfilt <> ""
                            INDEX ON &tagfield FOR &tagfilt TAG &tagname
                     ELSE
                            INDEX ON &tagfield TAG &tagname
                     ENDIF
                     memct = memct + 1
                ENDDO
            ENDIF
        ENDIF
ENDSCAN
SET DEFAULT TO &workpath
SET SAFETY ON
CLOSE DATA
